/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "int zahl = 4;\nzahl = zahl * 4;\nzahl = zahl / 2;\nzahl = zahl / 3;\nzahl = 2 + zahl;\nzahl = zahl % 3;\nzahl = 5; \nzahl = zahl % 3;\nzahl = 15 / 4;",
	"steps": [
		{
			"line": -1,
			"vars": {
				"instances": [],
				"vars": [],
				"scopes": []
			},
			"task": "Starte, indem du die erste Anweisung auswählst!"
		},
		{
			"task": "Das kennst du ja, oder? Führe die Deklaration und Wertezuweisung aus und trage die Auswirkungen in die Speichertabelle ein.",
			"line": 0,
			"vars": []
		},
		{
			"task": "<code>*</code> steht für die Multiplikation. Führe sie aus und trage die Auswirkung der Wertezuweisung in die Speichertabelle ein.",
			"line": 1,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 4
				}
			]
		},
		{
			"task": "<code>/</code> steht für die Division. Führe sie aus und trage die Auswirkung der Wertezuweisung in die Speichertabelle ein.",
			"line": 2,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 16
				}
			]
		},
		{
			"task": "Achtung: Weil Dividend und Divisor ganze Zahlen sind, ist das eine Ganzzahldivision (und <code>zahl</code> kann ohnehin nur ganze Zahlen speichern). Das Ergebnis der Ganzzahldivision ist daher nur die ganze Zahl ohne Rest oder Halbe. Du musst daher abrunden.",
			"line": 3,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 8
				}
			]
		},
		{
			"task": "Das kennst du ja, oder? Führe die Wertezuweisung aus und trage die Auswirkungen in die Speichertabelle ein.",
			"line": 4,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 2
				}
			]
		},
		{
			"task": "<code>%</code> ist ein <strong>Modulo</strong> genannter Operator: Er ermittelt den Rest bei einer Ganzzahldivision. Beispielsweise <code>5 % 2</code> ergibt <code>1</code>, weil 5 geteilt durch 2 als Ergebnis 2 <em>Rest 1</em> hat. Führe die Wertezuweisung aus und trage die Auswirkung der Wertezuweisung in die Speichertabelle ein.",
			"line": 5,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 4
				}
			]
		},
		{
			"task": "Das kennst du ja, oder? Führe die Wertezuweisung aus und trage die Auswirkungen in die Speichertabelle ein.",
			"line": 6,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 1
				}
			]
		},
		{
			"task": "Das kennst du ja jetzt, oder? Führe die Wertezuweisung aus und trage die Auswirkungen in die Speichertabelle ein.",
			"line": 7,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 5
				}
			]
		},
		{
			"line": 8,
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 2
				}
			]
		},
		{
			"line": "end",
			"vars": [
				{
					"key": "zahl",
					"type": "int",
					"value": 3
				}
			]
		}
	]
};
